#!/usr/bin/perl

## POWERSEEK PLUGIN ########################
#
# TITLE: Import/Export Utillity
# DIZ: Enables you to import text files with categories into the database.
# GRAPHIC: ic_misc.gif
# VERSION: 1.1
#
###########################################

########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "../config.cgi";

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################

## REQUIRES MySQL Version 3.23.23+  

#use FindBin;
#use lib $FindBin::Bin;
#use utf8;
#use Encode;
use CGI;
use DBI;
use acs;
use Time::Local; 
use obbuild;

&get_setup;
$q = CGI->new;

$default_permissions = 0777; ### PERMISSIONS THAT IS USED FOR TEMPORARY DATA FILES 

acs::check_access($username, $password, $q->param('username'), $q->param('password'));

$imports_per_screen = 10;
$web_wait = 3;

$strict_import = "N"; ### Y / N

##################################################################################

print "Content-type: text/html\n\n";
if ($q->param('fct') eq "") {&start;}

if ($q->param('fct') eq "do_import") {&do_import;}
if ($q->param('fct') eq "do_import2") {&do_import2;}


if ($q->param('fct') eq "get_top") {&get_top;}
if ($q->param('fct') eq "create_frame") {&create_frame;}

if ($q->param('fct') eq "import") {&import_screen;}

if ($q->param('fct') eq "export") {&export_screen;}
if ($q->param('fct') eq "do_export") {&do_export;}
if ($q->param('fct') eq "do_export2") {&do_export2;}
if ($q->param('fct') eq "get_export") {&get_export;}



##################################################

sub do_import2
{

$dformat = $q->param('dformat');
$delimit = $q->param('delimit');
$delimitoriginal = $q->param('delimit');

if ($delimit eq "tab") { $delimit = "\t"; }
if ($delimit eq "colon") { $delimit = ":";  }
if ($delimit eq "semicolon") { $delimit = ";";  }


### GET EXTRA KEYS/FIELDS 
$keydata = &get_file_contents("$data_dir/keys.dat");
@akeys = split (/\n/, $keydata);
$knr = @akeys;


### GET FIELDS THAT NEED TO BE IMPORTED

for ($ms = 1; $ms < (25 + $knr); $ms++)
	{ 
	$field_name = "f" . $ms;
	
	$linkstring = $linkstring . "&f" . $ms . "=" . $q->param($field_name);
	
	if ($q->param($field_name) ne "blank")
		{
			$the_cur_val = $q->param($field_name);
			$insert_fname[$ms - 1] = $the_cur_val;
		}
		else
		{
			$insert_fname[$ms - 1] = "";
		}
		
	}



###

$crit1 = chr(10);
$crit2 = chr(13);

$links_imported = 0;
$dirs_created = 0;

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }



################################################################################################

$nr = $q->param('nr'); $nr++;

$import_file_name = $nr . ".tmp";


if ((-e "$data_dir/dbbackup/$import_file_name") < 1) ### IF IMPORT FINISHED
{

	if ($q->param('filename') eq "import")
		{
		$fctv = "recount";
		}
		else
		{
		$fctv = "recount_import";
		}

$hbox = acs::get_heading_box("$web_url/ic_misc.gif", "Recounting Links... Please Wait...", qq[
<img src="$web_url/working.gif">
]);

print qq[<html>
<head>
<title>PowerSeek</title>
<meta HTTP-EQUIV="REFRESH" CONTENT="0;URL=$admin_url/recountlnks2.cgi?fct=$fctv">
<link href="$web_url/ps.css" rel="stylesheet" type="text/css"> 
</head>
<body>
$hbox
</body>
</html>
];

exit;
}


################################################################################################




#	open (EXP, "$data_dir/dbbackup/import.tmp");


	open (EXP, "$data_dir/dbbackup/$import_file_name");
	
	
		while (defined($line=<EXP>))
			{
			#$octets = encode("iso-8859-1", $line);
		 	#$line = decode("iso-8859-2", $octets);
		 	
			
			my @import_lines = split (/$delimit/, $line);

			$acount = 0; $insert_sql = ""; $insert_sql_dirs = "";
			
			
			#####################
			foreach $to_insert_item (@import_lines) ### CONSTRUCT INSERT STATEMENT
				{

				if (($insert_fname[$acount] ne "dirs_category") and ($insert_fname[$acount] ne ""))
					{
					$to_insert_item =~ s/\\//g; 
					$to_insert_item =~ s/'/\\'/g;
					$to_insert_item =~ s/\n//g;
					$to_insert_item =~ s/$crit1//g;
					$to_insert_item =~ s/$crit2//g;
					
						### BUILD SQL INSERT STATEMENT
						if ($insert_fname[$acount] =~ /links_/)
							{
							$toinsert_links = $insert_fname[$acount];
							
								### IF THIS IS A DATE
								if ($toinsert_links eq "links_urldate") 
									{

									if ($dformat eq "yyyy/mm/dd"){ ($pyear,$pmonth,$pday) = split(/\//, $to_insert_item); }
									if ($dformat eq "mm/dd/yyyy"){ ($pmonth,$pday,$pyear) = split(/\//, $to_insert_item); }
									if ($dformat eq "dd/mm/yyyy"){ ($pday,$pmonth,$pyear) = split(/\//, $to_insert_item); }
											
											$@ = "";
											eval {$time = timelocal(0,0,0, $pday,$pmonth,$pyear); };

											if ($@ eq "") {$time = timelocal(0,0,0, $pday,$pmonth,$pyear); $to_insert_item = $time;} else { $to_insert_item = time(); }
									$url_date_supplied = "true";
									} 
								########
							
							$toinsert_links =~ s/links_//gi;
							$insert_sql = $insert_sql . $toinsert_links . " = '$to_insert_item',";
							}
							### IF DIRECTORY
							elsif ($insert_fname[$acount] =~ /dirs_/)
							{
							$toinsert_dirs = $insert_fname[$acount];
							$toinsert_dirs =~ s/dirs_//gi;
							$insert_sql_dirs = $insert_sql_dirs . $toinsert_dirs . " = '$to_insert_item',";
							}
						
					}
					elsif ($insert_fname[$acount] eq "dirs_category")
					{
					
					### IF CATEGORY DOES NOT EXIST CREATE CATEGORY
					$display_data = "";
					
					($exist_cid, $display_data) = &check_category($to_insert_item);
						
						if ($display_data ne "") {$dirs_created++;}
					#print "<B>$to_insert_item</b><BR>";
					
					}
				
				$acount++;
				}
			###################
			
			
			if ($insert_sql ne "")
				{
				#print "INSERT INTO links SET $insert_sql cid = '$exist_cid'<BR><BR><BR>"; exit;
				$urldatecrit = "";
				if ($url_date_supplied ne "true") { $urldatecrit = ", urldate = '" . time() . "'"; }
				
				$sth = $dbh->prepare("INSERT INTO links SET $insert_sql cid = '$exist_cid' $urldatecrit");
				$sth->execute;
				if ($strict_import eq "Y") {$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";}}
				$links_imported++;
				}
			
			if (($insert_sql_dirs ne "") and ($display_data ne ""))
				{
				$insert_sql_dirs = substr($insert_sql_dirs, 0, length($insert_sql_dirs)-1);
				#print "<i>UPDATE dirs SET $insert_sql_dirs WHERE cid = '$exist_cid'</i><BR>";
				$sth = $dbh->prepare("UPDATE dirs SET $insert_sql_dirs WHERE cid = '$exist_cid'");
				$sth->execute;
				$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";}
				}
			
			
			}
	close (EXP);


if (defined($sth))
	{
	$sth->finish;
	}
$dbh->disconnect; 




$imp_refresh_link = "$admin_url/p_import.cgi?fct=do_import2&dformat=$dformat&delimit=$delimitoriginal&nr=$nr&filename=" . $q->param('filename') . $linkstring;

$nr1 = ($nr - 1) * 1000;


$hbox = acs::get_heading_box("$web_url/ic_misc.gif", "$nr1 Imported.. Please Wait...", qq[
<img src="$web_url/working.gif">
]);
 

print qq[

<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
<meta HTTP-EQUIV="REFRESH" CONTENT="0;URL=$imp_refresh_link">
</head>
<body>
$hbox
</body>
</html>


];





}






sub get_export
{

$file_name = "$data_dir/dbbackup/$db_name" . "_export.txt";

	open (EXP, "$file_name");
		while (defined($line=<EXP>))
			{
			print $line;
			}
	close (EXP);

}






sub do_export2
{
$file_name = "$data_dir/dbbackup/$db_name" . "_export.txt";
open(WRFILE, "> $file_name");
close (WRFILE);


$date_format = $q->param('dformat');
$delimit =  $q->param('delimit');


if ($delimit eq "tab") { $delimit = "\t"; }
if ($delimit eq "colon") { $delimit = ":";  }
if ($delimit eq "semicolon") { $delimit = ";";  }



### GET EXTRA KEYS/FIELDS 
$keydata = &get_file_contents("$data_dir/keys.dat");
@akeys = split (/\n/, $keydata);
$knr = @akeys;

for ($ms = 1; $ms < (25 + $knr); $ms++)
	{ 
	$field_name = "f" . $ms;
	
	if ($q->param($field_name) ne "blank")
		{
			$the_cur_val = $q->param($field_name);
			$export_string = $export_string . $the_cur_val . $delimit; ## \t
		}
		else
		{
			$export_string = $export_string . $delimit; ## \t
		}
		
	}

$export_string = substr($export_string, 0, length($export_string) - 1);


for ($ms = 0; $ms < length($export_string); $ms++)
	{ 
	if ((substr($export_string, length($export_string) - 1, 1) eq $delimit) and ($end_reached ne "true"))
		{
		$export_string = substr($export_string, 0, length($export_string) - 1);
		}
		else
		{
		$end_reached = "true";
		}
	}


#print "==> $export_string\n\n<BR><BR><BR>\n\n\n\n";

### DO EXPORT QUERY

$crit1 = chr(10);
$crit2 = chr(13);

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }



#### IF ONLY EXPORTING FROM A CERTAIN CATEGORY

$justcat =  $q->param('justcat');


if ($justcat ne "")
	{
	$sql = "SELECT * FROM dirs WHERE cid = '$justcat'";
	$sth = $dbh->prepare($sql);	
	$sth->execute;
	$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";}
	$rows = $sth->rows();
	if ($rows < 1) { acs::problem_popup("The category ID you specified is not valid.");	}

		while ( @row = $sth->fetchrow() )	
		{
			
			$lv = 1;
			for ($ms = 2; $ms < 18; $ms++)
				{ 
				   if ($row[$ms] ne "")
				   	{
						$row[$ms] =~ s/\///g;
						$curcat = $curcat . "AND (l" . $lv . " = '$row[$ms]') ";
						$lv++;
						}
				}
		}

	}

##################


	### $row[21] = lnkid
	$sth = $dbh->prepare("SELECT A.l1,A.l2,A.l3,A.l4,A.l5,A.l6,A.l7,A.l8,A.l9,A.l10,A.l11,A.l12,A.l13,A.l14,A.l15,A.l16,
										  A.ext2,A.description,A.keywords,A.catlock,A.crosslinkid,B.*
										  FROM dirs AS A, links AS B
										  WHERE 
										  (A.cid = B.cid) 
										  $curcat
										  ORDER BY A.shortname
										  "); ##AND (lnkid > '10200')
	
	
	$sth->execute;
	$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";}


if ($q->param('B1') ne "") ####### IF EXPORTING TO A FILE
{
$file_name = $q->param('filename');
open(WRFILE, ">> $file_name");	
}
else ### IF DOWNLOADING EXPORTED FILE
{

if ((-e "$data_dir/dbbackup") < 1)
	{ 
	mkdir ("$data_dir/dbbackup", $default_permissions);
	chmod($default_permissions,"$data_dir/dbbackup","$data_dir/dbbackup");
	}

$file_name = "$data_dir/dbbackup/$db_name" . "_export.txt";
open(WRFILE, ">> $file_name");
}





	while ( @row = $sth->fetchrow() )	
			{
	
				### GET CATEGORY
				$curcat = "";
				for ($ms = 0; $ms < 16; $ms++)
					{ 
					   if ($row[$ms] ne "")
					   	{
							$row[$ms] =~ s/\///g;
							$curcat = $curcat . $row[$ms] . "/";
							}
					}
				$curcat = substr($curcat, 0, length($curcat) - 1);
				
				### GET EXPORT LINK READY
				$tmp_export_str = $export_string;
				
				$tmp_export_str =~ s/dirs_category/$curcat/g;
				$tmp_export_str =~ s/dirs_ext2/$row[16]/g;
				$tmp_export_str =~ s/dirs_description/$row[17]/g;
				$tmp_export_str =~ s/dirs_keywords/$row[18]/g;
				$tmp_export_str =~ s/dirs_catlock/$row[19]/g;
				$tmp_export_str =~ s/dirs_crosslinkid/$row[20]/g;
				$tmp_export_str =~ s/links_title/$row[23]/g;
				$tmp_export_str =~ s/links_description/$row[24]/g;
				$tmp_export_str =~ s/links_keywords/$row[25]/g;
				
				$tmp_export_str =~ s/links_name/$row[29]/g;
				$tmp_export_str =~ s/links_email/$row[30]/g;
				$tmp_export_str =~ s/links_rating/$row[31]/g;
				$tmp_export_str =~ s/links_votes/$row[32]/g;
				$tmp_export_str =~ s/links_hits/$row[33]/g;
				$tmp_export_str =~ s/links_premium/$row[34]/g;
				$tmp_export_str =~ s/links_newsubm/$row[36]/g;
				$tmp_export_str =~ s/links_userid/$row[37]/g;
				

				$date_string = "";
				if (($tmp_export_str =~ /links_urldate/) and ($row[38] ne ""))
				{
					($sec,$min,$hour,$mday,$mon,$year,$wday,$ydat,$isdst) = localtime($row[38]);
					$year = "20" . substr($year, 1, 2); $mon++;

					if ($date_format eq "yyyy/mm/dd"){ $date_string = $year . "/" . $mon . "/" . $mday;	}
					if ($date_format eq "mm/dd/yyyy"){ $date_string = $mon . "/" . $mday . "/" . $year;	}
					if ($date_format eq "dd/mm/yyyy"){ $date_string = $mday . "/" . $mon . "/" . $year;	}
			
				#print  "--> $date_format<BR>";
				}
				$tmp_export_str =~ s/links_urldate/$date_string/g;
				
				
				
				
				$tmp_export_str =~ s/links_subscribed/$row[39]/g;
				$tmp_export_str =~ s/links_csuggest/$row[40]/g;
				$tmp_export_str =~ s/links_subs_expire/$row[42]/g;
				$tmp_export_str =~ s/links_lnkpassword/$row[43]/g;
				$tmp_export_str =~ s/links_rev_no/$row[44]/g;
				
				$tmp_export_str =~ s/links_url/$row[26]/g;

				if ($knr > 0)
				{
				$kcc = 0;
				foreach $kitem (@akeys)
					{
					($keyname, $visible, $size, $searched, $description, $na, $imgk, $nmbr) = split (/\t/, $kitem);
					$real_kname = "links_" . $keyname . "_cust";
					$tmp_export_str =~ s/$real_kname/$row[48 + $kcc]/g;
					$kcc++;
					}
				}
				
				$tmp_export_str =~ s/\n//g;
				$tmp_export_str =~ s/$crit1//g;
				$tmp_export_str =~ s/$crit2//g;
				
				#$to_export = $to_export . $tmp_export_str . "\n";
				
				print WRFILE $tmp_export_str . "\n";
				
			
			} 

$sth->finish;
$dbh->disconnect; 


close(WRFILE);

###############


if ($q->param('B1') ne "")
	{
	#$file_name = $q->param('filename');
	#open (EXPF, "> $file_name") or acs::problem_popup("The filename to be imported does not exist.");	
	#	print EXPF $to_export;
	#close (EXPF);


$hbox = acs::get_heading_box("$web_url/ic_misc.gif", "Export Complete", qq[All links found has been written to:<BR>
<b>$file_name</b><BR>
<a href="$admin_url/p_import.cgi">Click Here to Continue</a> or <a href="javascript:onClick=window.close()">Here to close</a> this window.</font>
]);

print qq[
<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<body>
$hbox
</body>
</html>
];
	}
	else
	{
	
	$download_url = "$admin_url/p_import.cgi?fct=get_export"; 
	
	
	$hbox = acs::get_heading_box("$web_url/ic_misc.gif", "Export Complete", qq[
	<a href="$download_url"><strong>Right Click Here and Choose 'Save As' to Download the Exported File</strong></a><br>
	<BR>
	<a href="$admin_url/p_import.cgi">Click Here to Continue</a> 
	]);

	
print qq[
<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<body>
$hbox
</body>
</html>


];
	
	}








}










sub do_export
{

$justcat = $q->param('crosslinkid');

### IF EXPORT BUTTON WAS PRESSED TO EXPORT TO FILE CHECK IF WE CAN WRITE TO THE FILE
if ($q->param('B1') ne "")
	{
	$file_name = $q->param('filename');
	open (EXPF, "> $file_name") || acs::problem_popup("The filename with it's path where links are going to be exported to does not exist or there is no permission to write to that location. $@");	
		print EXPF "TEST";
	close (EXPF);
	$b1crit = "B1=export";
	}
	else
	{
	$b1crit =  "B2=Download";
	}

$extra_fnr = $q->param('extra_fnr');


for ($ms = 1; $ms < (25 + $extra_fnr); $ms++)
	{ 
	$fvname = "f" . $ms;
	
	$pass_val = $pass_val . $fvname . "=" . $q->param($fvname) . "&";
	}


$delimit =  $q->param('delimit');

$dformat = $q->param('dformat');

$link = $admin_url . "/p_import.cgi?" . "$pass_val" . "extra_fnr=" . $extra_fnr . "&fct=do_export2&dformat=$dformat&filename=$file_name&delimit=$delimit&" . $b1crit . "&justcat=$justcat";  #obbuild::check_export_data($link);


$hbox = acs::get_heading_box("$web_url/ic_misc.gif", "Exporting Data... Please Wait...", qq[
<img src="$web_url/working.gif">
]);


print qq[
<html>
<head>
<title>PowerSeek</title>
<meta HTTP-EQUIV="REFRESH" CONTENT="0;URL=$link">
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<body>
$hbox
</body>
</html>

];



}






sub export_screen
{


### GET REST OF THE FIELDS AND BUILD SELECTION BOXES 

### FIELDS TO EXPORT IN SELECTION BOX
@normal_fields = ("blank:Leave Blank",
						"dirs_category:Category Name",
						"dirs_ext2:Category Custom Title",
						"dirs_description:Category Meta Description",
						"dirs_keywords:Category Keywords",
						"dirs_catlock:Category Locked",
						"dirs_crosslinkid:Category Cross Linked",
						"links_title:Link Title",
						"links_description:Link Description",
						"links_keywords:Link Keywords",
						"links_url:Link URL",
						"links_name:Contact Name",
						"links_email:Contact Email",
						"links_rating:Rating",
						"links_votes:Votes",
						"links_hits:Hits",
						"links_premium:Premium Link or Not (Y/N)",
						"links_newsubm:New Submission or Not (Y/N)",
						"links_userid:User ID (If linked to account)",
						"links_urldate:Date of Listing",
						"links_subscribed:Subscribed",
						"links_csuggest:Category Suggested (Submission Time)",
						"links_subs_expire:Premium Link Expiry Date",
						"links_lnkpassword:Link Password",
						"links_rev_no:Number of Reviews/Comments");



### GET EXTRA KEYS/FIELDS 

$keydata = &get_file_contents("$data_dir/keys.dat");
@akeys = split (/\n/, $keydata);
$knr = @akeys;


$kcount = 0;
foreach $kitem (@akeys)
	{
	($keyname, $visible, $size, $searched, $description, $na, $imgk, $nmbr) = split (/\t/, $kitem);
	
	$pushval = "links_" . "$keyname" . "_cust:" . $description  . " (Extra Field)";
	push(@normal_fields, $pushval);
	$kcount++;

	} 


### WORK OUT SELECTION BOXES


for ($ms = 1; $ms < (25 + $kcount); $ms++)
	{ 
	$fnumber = $ms;
	$fieldname = "f" . "$ms";

	$sel_count = 0; $normal_fields = "";
	foreach $f_item(@normal_fields)
		{
		($fielf_value, $field_diz) = split (/:/, $f_item);
		 if ($sel_count == $ms) { $selected_val = "selected"; } else { $selected_val = ""; }
		 $normal_fields = $normal_fields . qq[<option value="$fielf_value" $selected_val>$field_diz</option>];
		 $sel_count++;
		}
	
$selboxes_with_table = $selboxes_with_table . qq[
<tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
<td width="10%" valign="top" class="normaltext"><strong>Field $fnumber: </strong></td>
<td width="90%" valign="top" class="normaltext">
<select name="$fieldname" size="1">
$normal_fields
$koptions
</select></td>
</tr>
	];
	
	}


$hbox = acs::get_heading_box("$web_url/ic_misc.gif", "Export", qq[
Please configure the export criteria below.
]);


print qq[

<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">

<script LANGUAGE="JavaScript">
<!-- Hide

  function popup(loc,ww,hh)
   {
    var mywidth = (ww + 0);
    var myheight = (hh + 0);
    var myspecs = "'menubar=0,status=1,resizable=1,location=0,titlebar=1,toolbar=1,scrollbars=1,width=" + mywidth + ",height=" + myheight + "'";
	var random = parseInt(Math.random()*10000)

	  var popupwin = null;
      myWindow = open (loc, popupwin + random, myspecs);
      myWindow.moveTo(400,0);
      myWindow.focus();

    }
 // End Hide -->
 </script> 

</head>
<body>

$hbox
<form method="POST" action="$admin_url/p_import.cgi" name="addu">
  <input type="hidden" name="fct" value="do_export"><input type="hidden" name="extra_fnr"
  value="$kcount"><table border="0" cellspacing="1" width="100%" cellpadding="6"
  style="border: 1px solid rgb(216,216,216)">
    <tr>
      <td width="10%" background="$web_url/bar6.gif" class="normaltext"><strong>Field</strong></td>
      <td width="90%" background="$web_url/bar6.gif" class="normaltext"><strong>Value</strong></td>
    </tr>
    $selboxes_with_table 
    $extra_field_boxes
    <tr>
      <td width="963" colspan="2" class="normaltext">The fields above will be placed in the order that you select.
      Records will be terminated by a <strong>carriage return. </strong></td>
    </tr>
    <tr>
      <td width="963" colspan="2" class="normaltext"><strong>If you are exporting dates in what format should they
      be? </strong>
        <select size="1" name="dformat">
        <option value="yyyy/mm/dd"> yyyy/mm/dd </option>
        <option value="mm/dd/yyyy"> mm/dd/yyyy </option>
        <option value="dd/mm/yyyy"> dd/mm/yyyy </option>
      </select> </td>
    </tr>
    <tr>
      <td width="963" colspan="2" class="normaltext"><strong>Type of delimitation used in file to be
      exported:&nbsp; </strong>
        <select size="1" name="delimit">
        <option value="tab" selected> Tabs (Recommended) </option>
        <option value="colon"> Colon (:) </option>
        <option value="semicolon"> Semi-Colon (;) </option>
      </select> </td>
    </tr>
    <tr>
      <td width="963" colspan="2" class="normaltext"><strong>Export Only Links and Categories From Category
      ID:&nbsp; </strong>
        <input type="text" name="crosslinkid" size="20"> ( <a href="$admin_url/admin67.cgi" onClick="popup('$admin_url/admin67.cgi',750,600);return false;"><b>Browser</b></a> )<br>
      Click the 'Browser' link to assign/select a category ID.
      <br>
      <br>
      </td>
    </tr>
    <tr>
      <td width="963" colspan="2" class="normaltext"><strong>Provide a full server path where the file should be
      placed: <br>
      <input type="text" name="filename" size="52"> </strong><input type="submit"
      value="Export to File" name="B1"> <strong><br>
      <br>
      <b>--or-- </b><p><input type="submit" value="Download File" name="B2"> </strong></td>
    </tr>
  </table>
  <table border="0" cellpadding="0" cellspacing="0" width="100%"
  background="$web_url/shadow.gif">
    <tr>
      <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_ </font></td>
      <td width="99%"></td>
    </tr>
  </table>
</form>





</body>
</html>

];


}













sub start
{

$hbox = acs::get_heading_box("$web_url/ic_misc.gif", "Import/Export Utillity", qq[
Enables you to import text files with categories into the database or export links with their categories.
]);


print qq[
<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<body>
$hbox


<table border="0" cellspacing="1" width="100%" cellpadding="6" bgcolor="#D8D8D8" height="46">
  <tr>
    <td width="100%" height="30" bgcolor="#FFFFFF" class="normaltext">What would you like to do? <strong><a
    href="$admin_url/p_import.cgi?fct=import">Import</a> | <a
    href="$admin_url/p_import.cgi?fct=export">Export</a></strong></td>
  </tr>
</table>
<table border="0" cellpadding="0" cellspacing="0" width="100%" background="$web_url/shadow.gif">
  <tr>
    <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font> </td>
    <td width="99%"></td>
  </tr>
</table>

</body>
</html>
];


}




sub do_import
{


### IF CATEGORY DOES NOT EXIST CREATE CATEGORY
### ($exist_cid, $display_data) = &check_category($category1);

if ((-e "$data_dir/dbbackup") < 1)
	{ 
	mkdir ("$data_dir/dbbackup", $default_permissions);
	chmod($default_permissions,"$data_dir/dbbackup","$data_dir/dbbackup");
	}



opendir(DIR,"$data_dir/dbbackup");
@files = readdir(DIR);
@files = sort(@files);
foreach $filename (@files)
	{
	if (substr($filename, length($filename) - 4, 4) eq ".tmp")
		{ 
		unlink ("$data_dir/dbbackup/$filename");
		}
	} 



if ($q->param('filename') eq "import")
{
$importdata = &get_file_contents("$data_dir/import.txt");

open (OUTFILE, ">$data_dir/dbbackup/import.tmp");
print OUTFILE $importdata;
close (OUTFILE);


$lncounter = 0; $impfn = 1;
open (EXP, "$data_dir/dbbackup/import.tmp");
	while (defined($line=<EXP>))
		{
		$lncounter++;

		if ($lncounter == 1)
			{
			open (IMPD, "> $data_dir/dbbackup/$impfn.tmp");
			}

		print IMPD $line;

		if ($lncounter == 1000)
			{
			close (IMPD);
			$impfn++;
			$lncounter = 0;
			}
		}
close (EXP);

open (IMPNR, "> $data_dir/dbbackup/nr.tmp");
	print IMPNR $impfn;
close (IMPNR);



}
else
{
$file_to_import = $q->param('file_to_import');
$file = $q->param('file_to_import');

if ($file_to_import eq "") { acs::problem_popup("The filename to be imported does not exist.");	}


	open (OUTFILE, ">$data_dir/dbbackup/import.tmp");
		while ($bytesread = read($file, $buffer, 1024)) 
			{
			print OUTFILE $buffer;
			}
	close (OUTFILE);
	

$lncounter = 0; $impfn = 1;
open (EXP, "$data_dir/dbbackup/import.tmp");
	while (defined($line=<EXP>))
		{
		$lncounter++;

		if ($lncounter == 1)
			{
			open (IMPD, "> $data_dir/dbbackup/$impfn.tmp");
			}

		print IMPD $line;

		if ($lncounter == 1000)
			{
			close (IMPD);
			$impfn++;
			$lncounter = 0;
			}
		}
close (EXP);

open (IMPNR, "> $data_dir/dbbackup/nr.tmp");
	print IMPNR $impfn;
close (IMPNR);


}



### DISPLAY 'IMPORTING FILE'
$extra_fnr = $q->param('extra_fnr');

for ($ms = 1; $ms < (25 + $extra_fnr); $ms++)
	{ 
	$fvname = "f" . $ms;
	
	$pass_val = $pass_val . $fvname . "=" . $q->param($fvname) . "&";
	
	if ($q->param($fvname) eq "dirs_category"){ $found_dir = "true"; }
	}


if ($found_dir ne "true")
	{
	acs::problem_popup("The records need at least a category. You cannot import links that has no categories.");	
	}



$dformat = $q->param('date_format'); 

$delimit = $q->param('delimit');



$link = $admin_url . "/p_import.cgi?" . "$pass_val" . "extra_fnr=" . $extra_fnr . "&fct=do_import2&dformat=$dformat&delimit=$delimit&"; #&obbuild::check_import_data($file_to_import);


if ($q->param('filename') eq "import") { $link = $link . "&filename=import"; } ### IF IMPORTING FROM SETUP.CGI


$hbox = acs::get_heading_box("$web_url/ic_misc.gif", "Importing Data... Please Wait...", qq[
<img src="$web_url/working.gif">
]); 


print qq[
<html>
<head>
<title>PowerSeek</title>
<meta HTTP-EQUIV="REFRESH" CONTENT="0;URL=$link">
<link href="$web_url/ps.css" rel="stylesheet" type="text/css"> 
</head>
<body>
$hbox
</body>
</html>
];



}





sub import_lines
{

my (@to_import) = @_;

#### CONNECT TO DATABASE
if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }

$dbh->do("set names latin2");
#$dbh->do("SET NAMES utf8");
#$dbh->do("set names CP1251");



foreach $i_item (@to_import)
	{
	$i_item =~ s/\n//g;
	$crit = chr(10); $i_item =~ s/$crit//g;
	$crit = chr(13); $i_item =~ s/$crit//g;

	if ($i_item ne "")
	{
	
	if ($delimit eq "Tab") { $ndelim = "\t"; }
	if ($delimit eq "Comma") { $ndelim = ","; }
	if ($delimit eq "Space") { $ndelim = " "; }
	
	@oneline = split (/$ndelim/, $i_item);

	$category1 = $oneline[0];
	$category1 = acs::remove_leading_spacing($category1);
	
	$title1 = $oneline[1]; $title1 =~ s/'/\\'/g;
	$diz1 = $oneline[2]; $diz1 =~ s/'/\\'/g;
	$url1 = $oneline[3]; $url1 =~ s/'/\\'/g;
	$keywords1 = $oneline[4]; $keywords1 =~ s/'/\\'/g;
	$hits = $oneline[5]; $hits =~ s/'/\\'/g;
	$votes1 = $oneline[6]; $votes1 =~ s/'/\\'/g;
	$rating1 = $oneline[7]; $rating1 =~ s/'/\\'/g;
	
	$import_error= "";
	$import_problem="";

	### CHECK FOR ERRORS
			if (($title1 eq "") or ($url1 eq "") or ($category1 eq ""))
				{
				$import_error = "true"; $import_problem = "Could not import line: $i_item - No Title, URL or Category\n";
				}

				if ($i_item !~ /$ndelim/i)
				{
				$import_error = "true"; $import_problem = "Could not find $delimit delimiter in line: $i_item - No Title, URL or Category\n";
				}

	
	### CHECK IF CATEGORY EXISTS AND IF IT DOESN'T CREATE CATEGORY
	
	if ($import_error ne "true")
		{
		($exist_cid, $display_data) = &check_category($category1);
		$display_crit2 = $display_crit2 . $display_data;
		}
	
	### INSERT LINKS
	#print "==> $title1 - $exist_cid<BR>";
		
		$found_dup = "false";
		if (($q->param('duplicates') eq "ON") and ($import_error ne "true"))
			{

				if (substr($url1, length($url1) -1, 1) eq "/")
				{
				$url2 = substr($url1, 0, length($url1) - 1);
				$sql = "SELECT lnkid FROM links WHERE url = '$url1' OR url = '$url2'";
				}
				else
				{
				$sql = "SELECT lnkid FROM links WHERE url = '$url1'";
				}
			
			$sth = $dbh->prepare($sql);
			if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }
			$sth->execute;
			$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";} 			
			$rows = $sth->rows();
			
			if ($rows > 0)
				{
				if ($q->param('fct') eq "do_import") {$display_crit2 = $display_crit2 . "<BR>" . "Not Imported: <b>$title1 : <font color=\"#FF0000\">Duplicate</font></b><BR>";}
				$found_dup = "true";
				$import_problem = "Could not import <b><a href=\"$url1\" target=\"_blank\">$title1</a></b>: Would Create a Duplicate\n";
				}
				
			}

		
		if (($found_dup eq "false") and ($import_error ne "true"))
		{
		$date = time();
		
		if ($q->param('fct') eq "do_import") {$display_crit2 = $display_crit2 . "<BR>" . "Imported: <b>$title1</b><BR>";}
		
		$sql = "INSERT INTO links SET cid = '$exist_cid',
												title = '$title1',
												description = '$diz1',
												url = '$url1',
												keywords = '$keywords1',
												hits = '$hits',
												votes = '$votes1',
												rating = '$rating1',
												urldate = '$date'
												";
		$sth = $dbh->prepare($sql);
		if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }
		$sth->execute;
		$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";} 			
		}
	
	
			### WRITE LOG FILE OF IMPORT PROBLEMS
			if ($import_problem ne "")
			{
				open (IMP, ">> $data_dir/import_errors.log");
					print IMP "$import_problem";
				close (IMP);
			}
	
	
	}
	
	}

$sth->finish;
$dbh->disconnect; 

$display_crit2 = "<font face=\"Verdana\" size=\"1\">" . $display_crit2 . "</font>";


return ($display_crit2);
}










sub check_category
{

my ($thecat) = @_;

my (@catitems, $wherecat, $wcnt, $citem, $wherecat, $create_sql, $shortname, $currentsel, 
    $sql, $rows, $create_sql2, $cidreturn, $citem_display, $display_details);

@catitems = split (/\//, $thecat);


### BUILD SQL QUERY
$wcnt = 1;

foreach $citem (@catitems)
	{

	$citem =~ s/\n//g;
	$crit = chr(10); $citem =~ s/$crit//g;
	$crit = chr(13); $citem =~ s/$crit//g;
	$citem =~ s/\t//g;
	$citem =~ s/_/ /g;
	
	if ($citem ne "")
		{
		$citem =~ s/'/\\'/g;
		$wherecat = $wherecat . " (l" . $wcnt . " = '$citem') AND";
		$create_sql = $create_sql . " l" . $wcnt . " = '$citem', ";
		$shortname = $citem;
		$citem_display = $citem_display . "/$citem";


			### CHECK IF CATEGORY EXISTS - IF NOT CREATE CATEGORY
			$currentsel = $wherecat . " level = $wcnt";
			
			$sql = "SELECT cid FROM dirs WHERE $currentsel";
			
			###C print "==1> $sql <BR>LINE: ---$citem---<BR><BR>";
			
			$sth = $dbh->prepare($sql);
			if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }
			$sth->execute;
			$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";} 			
			$rows = $sth->rows();
			while ( @row = $sth->fetchrow() ){$cidreturn = $row[0];}
			
 			
 			### CREATE CATEGORY IF NON-EXISTANT
 			if ($rows == 0) 
 					{

 					$create_sql2 = $create_sql;

 					 for ($leveladder = ($wcnt + 1); $leveladder < 17; $leveladder++) 
						{
	 					$create_sql2 = $create_sql2 . " l" . $leveladder . " = '',";
	 					}
 					
 					$create_sql2 = $create_sql2 . "level = '$wcnt', shortname ='$shortname'";
 					
 					
 					#$create_sql2 = encode("iso-8859-2", $create_sql2);

							#open (DD, "> $data_dir/tmp.tmp");
							#	print DD $thecat . "\n";
							#close (DD);
 					
 					$sql = "INSERT INTO dirs SET $create_sql2";
 					
 						###C print "!==> $sql <BR><BR>";
						$sth = $dbh->prepare($sql);
						if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }
						$sth->execute;
						$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";} 			
						$rows = $sth->rows();
							
							### GET LAST INSERTED ID
							$sth = $dbh->prepare("SELECT cid FROM dirs WHERE cid = LAST_INSERT_ID()");
							$sth->execute;
							$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";}
							while ( @row = $sth->fetchrow() )	
								{
								$cidreturn = $row[0]; 
								} 
						
						### INDICATE THAT A CATEGORY HAS BEEN CREATED
						$display_details = "true";
 					}
			
		$wcnt++;
		}
	}

return ($cidreturn, $display_details);
}







sub import_screen
{

unlink ("$data_dir/import_errors.log");
open (IMP, "> $data_dir/import_errors.log");
close (IMP);
chmod($default_permissions,"$data_dir/import_errors.log","$data_dir/import_errors.log");


#<input type="hidden" name="fct" value="create_frame">



### FIELDS TO IMPORT
@normal_fields = ("blank:Blank",
						"dirs_category:Category Name",
						"dirs_ext2:Category Custom Title",
						"dirs_description:Category Meta Description",
						"dirs_keywords:Category Keywords",
						"dirs_catlock:Category Locked",
						"dirs_crosslinkid:Category Cross Linked",
						"links_title:Link Title",
						"links_description:Link Description",
						"links_keywords:Link Keywords",
						"links_url:Link URL",
						"links_name:Contact Name",
						"links_email:Contact Email",
						"links_rating:Rating",
						"links_votes:Votes",
						"links_hits:Hits",
						"links_premium:Premium Link or Not (Y/N)",
						"links_newsubm:New Submission or Not (Y/N)",
						"links_userid:User ID (If linked to account)",
						"links_urldate:Date of Listing",
						"links_subscribed:Subscribed",
						"links_csuggest:Category Suggested (Submission Time)",
						"links_subs_expire:Premium Link Expiry Date",
						"links_lnkpassword:Link Password",
						"links_rev_no:Number of Reviews/Comments");



### GET EXTRA KEYS/FIELDS 

$keydata = &get_file_contents("$data_dir/keys.dat");
@akeys = split (/\n/, $keydata);
$knr = @akeys;


$kcount = 0;
foreach $kitem (@akeys)
	{
	($keyname, $visible, $size, $searched, $description, $na, $imgk, $nmbr) = split (/\t/, $kitem);
	
	$pushval = "links_" . "$keyname" . "_cust:" . $description  . " (Extra Field)";
	push(@normal_fields, $pushval);
	$kcount++;

	} 


### WORK OUT SELECTION BOXES


for ($ms = 1; $ms < (25 + $kcount); $ms++)
	{ 
	$fnumber = $ms;
	$fieldname = "f" . "$ms";

	$sel_count = 0; $normal_fields = "";
	foreach $f_item(@normal_fields)
		{
		($fielf_value, $field_diz) = split (/:/, $f_item);
		 if ($sel_count == $ms) { $selected_val = "selected"; } else { $selected_val = ""; }
		 $normal_fields = $normal_fields . qq[<option value="$fielf_value" $selected_val>$field_diz</option>];
		 $sel_count++;
		}
	
$selboxes_with_table = $selboxes_with_table . qq[
<tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
<td width="10%" valign="top" class="normaltext"><strong>Field $fnumber: </strong></td>
<td width="90%" valign="top" class="normaltext">
<select name="$fieldname" size="1">
$normal_fields
$koptions
</select></td>
</tr>
	];
	
	}


$hbox = acs::get_heading_box("$web_url/ic_misc.gif", "Import", qq[
Please configure the import criteria below.
]);


print qq[
<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<body>
$hbox



<table border="0" cellspacing="1" width="100%" cellpadding="10" bgcolor="#D8D8D8">
  <tr>
    <td bgcolor="#FFFFFF" width="963"><strong><span class="normaltext">Import Rules: </span></strong><ul>
      <li class="normaltext"><img src="$web_url/critical.gif"> <strong>- <font color="#FF0000">Make
        a backup before importing data.</font> </strong>You can find instructions on doing a
        complete backup of all your data, settings and templates in the <strong><a
        href="http://www.focalmedia.net/pseekmanual/pseek9.html#9.6" target="_blank">PowerSeek
        documentation.</a><br>
        <font color="#FF0000">Use this Importer with Caution:</font> Importing files that is not
        in the correct format can have undesired results. Ensure that the file format is correct. </strong><br>
        &nbsp;&nbsp; </li>
      <li class="normaltext">The file you are importing must be a tab,colon or semi-colon
        delimited text file. <br>
        &nbsp; </li>
      <li class="normaltext">Each record inside the text file must end with a carriage return. <br>
        &nbsp; <strong>&nbsp;&nbsp; </strong></li>
      <li class="normaltext">Each record should at least have a <strong>category </strong>present,
        otherwise it won't be imported. If you want to import categories only, then you may do
        that by only having categories on single lines. <br>
        &nbsp;&nbsp; </li>
      <li class="normaltext">Categories will automatically be created when importing listings. <br>
        &nbsp;&nbsp; </li>
      <li class="normaltext"><strong><font color="#FF0000">Important Note:</font> A category with
        it's sub levels needs to be seperated via slashes. (The / character) For example: </strong><br>
        Business &amp; Money/Investments/Stocks </li>
    </ul>
    </td>
  </tr>
</table>

<table border="0" cellpadding="0" cellspacing="0" width="100%"
background="$web_url/shadow.gif">
  <tr>
    <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font> </td>
    <td width="99%"></td>
  </tr>
</table>

<form method="POST" action="$admin_url/p_import.cgi" ENCTYPE="multipart/form-data">
  <input type="hidden" name="fct" value="do_import"><input type="hidden" name="extra_fnr"
  value="$kcount"><table border="0" cellspacing="0" width="100%" cellpadding="0">
    <tr>
      <td bgcolor="#FFFFFF" class="normaltext"><b>Please tell the importer in what format your
      file to be imported is: </b><br>
      &nbsp; <table border="0" cellpadding="6" cellspacing="1" width="100%"
      style="border: 1px solid rgb(192,192,192)">
        <tr>
          <td width="10%" valign="top" class="normaltext" background="$web_url/bar6.gif"><strong>Field
          </strong></td>
          <td width="90%" valign="top" class="normaltext" background="$web_url/bar6.gif"><strong>Value
          </strong></td>
        </tr>
        $selboxes_with_table
        $extra_field_boxes 
        <tr>
          <td width="100%" valign="top" class="normaltext" colspan="2"><strong>If you are importing
          dates in what format are they? </strong><select size="1" name="date_format">
            <option value="yyyy/mm/dd"> yyyy/mm/dd </option>
            <option value="mm/dd/yyyy"> mm/dd/yyyy </option>
            <option value="dd/mm/yyyy"> dd/mm/yyyy </option>
          </select> <strong></strong></td>
        </tr>
        <tr>
          <td width="100%" valign="top" class="normaltext" colspan="2"><strong>Type of delimitation
          (fields seperated by) used in file to be imported:&nbsp; </strong><select size="1"
          name="delimit">
            <option value="tab" selected> Tabs (Recommended) </option>
            <option value="colon"> Colon (:) </option>
            <option value="semicolon"> Semi-Colon (;) </option>
          </select> </td>
        </tr>
        <tr>
          <td width="100%" valign="top" class="normaltext" colspan="2"><input type="file"
          name="file_to_import" size="50"> </td>
        </tr>
        <tr>
          <td width="100%" valign="top" class="normaltext" colspan="2"><input type="submit"
          value="Import" name="B1"> </td>
        </tr>
      </table>
      </td>
    </tr>
  </table>
  <table border="0" cellpadding="0" cellspacing="0" width="100%"
  background="$web_url/shadow.gif">
    <tr>
      <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_ </font></td>
      <td width="99%"></td>
    </tr>
  </table>
</form>

</body>
</html>

];

}




####################################################################################

sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################





 


